/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros del archivo de TAM_SolicitudesParaAprobar__c
    					y actualiza los datos del Lead asociado a la solicutd.

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             	Autor                       Descripcion
    1.0    05-Noviembre-2019    Héctor Figueroa             Creación
******************************************************************************* */

public without sharing class TAM_SolicitudesParaAprobarTriggerHandler extends TriggerHandler {

    public static String VaRtAccRegDist = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Distribuidor').getRecordTypeId();
	public static String VaRtAccRegCteCorp = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();

	public static String VaRtAccRegPM = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();
	public static String VaRtAccRegPF = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();

	public static String VaRtAccRegPMCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();
	public static String VaRtAccRegPFCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo CP').getRecordTypeId();

	public static String VaRtAccRegPMNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral No Vigente').getRecordTypeId();
	public static String VaRtAccRegPFNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica No Vigente').getRecordTypeId();
	public static String VaRtAccRegPMPreAut = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral Preautorizado').getRecordTypeId();
	public static String VaRtAccRegPFPreAut = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica Preautorizado').getRecordTypeId();
	
	public static String VaRtLeadEstAuto = Schema.SObjectType.Lead.getRecordTypeInfosByName().get('Estatus Autorización').getRecordTypeId();
	public static String VaRtLeadCteCreado = Schema.SObjectType.Lead.getRecordTypeInfosByName().get('Cliente Creado').getRecordTypeId();

	public static String VaRtLeadSolFlot = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Flotilla').getRecordTypeId();
	public static String VaRtLeadSolProg = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
	
	public static String VaRtLeadSolFlotSoloLec = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Flotilla solo lectura').getRecordTypeId();
	public static String VaRtLeadSolProgSoloLec = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Programa solo lectura').getRecordTypeId();

	public static String VaRtCLienteSolPreautoriza = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Cliente Preautorizado').getRecordTypeId();
	public static String VaRtCLienteSolActivacion = Schema.SObjectType.TAM_SolicitudesParaAprobar__c.getRecordTypeInfosByName().get('Activación de Cliente').getRecordTypeId();
	
    private List<TAM_SolicitudesParaAprobar__c> solicitudes;
    private Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld;
    
    public TAM_SolicitudesParaAprobarTriggerHandler(){
        System.debug(LoggingLevel.INFO,'Inicia TAM_SolicitudesParaAprobarTriggerHandler');  
        this.solicitudes = (List<TAM_SolicitudesParaAprobar__c>) trigger.new;
        this.mapsolicitudesOld = (Map<id,TAM_SolicitudesParaAprobar__c>) trigger.oldMap;
    }

    public override void beforeUpdate(){
    	System.debug(LoggingLevel.INFO,'Inicia beforeUpdate...');
        actualizaTipoRegSolicitud(this.solicitudes, this.mapsolicitudesOld);   
    }
    
    //Para el evwento del afterUpdate
	public override void afterUpdate(){
		System.debug(LoggingLevel.INFO,'Inicia afterUpdate...');
        actualizaDatosCandidato(this.solicitudes, this.mapsolicitudesOld);
        actualizaDatosClientePreautorizado(this.solicitudes, this.mapsolicitudesOld);
        actualizaDatosClienteActivado(this.solicitudes, this.mapsolicitudesOld);
    }        

   public static void actualizaTipoRegSolicitud (List<TAM_SolicitudesParaAprobar__c> solicitudes, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaTipoRegSolicitud');
        List<Lead> LleadUpd = new List<Lead>();
        List<TAM_SolicitudesParaAprobar__c> lTAM_SolicitudesParaAprobarUps = new List<TAM_SolicitudesParaAprobar__c>();   
        Map<String, String> mapNomCandIdCand = new Map<String, String>();
        List<Lead> lLead = new List<Lead>();
        Map<String, Integer> mapNameRangoIdProgramaRango = new Map<String, Integer>();
        Map<String, Integer> mapNameRangoIdProgramaRangoLead = new Map<String, Integer>();

        //Busca el rango asoaciado a setIdProgramaRango
        for (Rangos__c Rangos : [Select r.id, r.Name, r.DiasVigentes__c From Rangos__c r]){
        	mapNameRangoIdProgramaRango.put(Rangos.Name, Integer.valueOf(Rangos.DiasVigentes__c));
        	mapNameRangoIdProgramaRangoLead.put(Rangos.id, Integer.valueOf(Rangos.DiasVigentes__c));
        }
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler mapNameRangoIdProgramaRango: ' + mapNameRangoIdProgramaRango.KeySet());
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler mapNameRangoIdProgramaRango: ' + mapNameRangoIdProgramaRango.Values());
        
        //Recorre la lista de solicitudes
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	//Ve si el estatus de la autorización es 'solicitudes'
        	//if (Sol.TAM_Estatus__c == 'Rechazado' || Sol.TAM_Estatus__c == 'Autorizado' && Sol.RecordTypeId != VaRtCLienteSolActivacion)
        	//	Sol.RecordTypeId = Sol.TAM_TipoCandidato__c == 'Flotilla' ? VaRtLeadSolFlotSoloLec : VaRtLeadSolProgSoloLec;
	        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler Sol.TAM_ProgramaRangoPreautor__c: ' + Sol.TAM_ProgramaRangoPreautor__c + ' TAM_ProgramaRandoRef__c: ' + Sol.TAM_ProgramaRandoRef__c);

			//Inicializa los datos de los dias de vigencia
   	    	Integer cIntDiasVigentes = 0;
        	if (Sol.TAM_Estatus__c == 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion){
                cIntDiasVigentes = mapNameRangoIdProgramaRango.containsKey(Sol.TAM_ProgramaRangoPreautor__c) ? mapNameRangoIdProgramaRango.get(Sol.TAM_ProgramaRangoPreautor__c) : 
                (mapNameRangoIdProgramaRangoLead.containsKey(Sol.TAM_ProgramaRandoRef__c) ? mapNameRangoIdProgramaRangoLead.get(Sol.TAM_ProgramaRandoRef__c) : 0); //TAM_ProgramaRangoPreautor__c
        	}    
        	if (Sol.TAM_Estatus__c == 'Autorizado' && (Sol.RecordTypeId == VaRtLeadSolFlot || Sol.RecordTypeId == VaRtLeadSolProg)){
    			cIntDiasVigentes = mapNameRangoIdProgramaRangoLead.containsKey(Sol.TAM_ProgramaRandoRef__c) ? mapNameRangoIdProgramaRangoLead.get(Sol.TAM_ProgramaRandoRef__c) : 
    			(mapNameRangoIdProgramaRango.containsKey(Sol.TAM_ProgramaRangoPreautor__c) ? mapNameRangoIdProgramaRango.get(Sol.TAM_ProgramaRangoPreautor__c) : 0);
        	}
	        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler cIntDiasVigentes: ' + cIntDiasVigentes);
    		
			//Inicializa las fecha de inicio y fin de la vigencia
			Date dFechaIni = Date.today();
			Date dFechaFin = Date.today();

			//Ve que fechas capturo en el campo de Sol.TAM_FechaVigenciaInicio__c y  Sol.TAM_FechaVigenciaFin__c;
			if (Sol.TAM_FechaVigenciaInicio__c == null && Sol.TAM_FechaVigenciaFin__c == null)
				dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
			if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null){
				dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
				dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
			}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null
			if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c != null){
				dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
				dFechaFin = Sol.TAM_FechaVigenciaFin__c; 
			}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null				

	        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler dFechaIni: ' + dFechaIni + ' dFechaFin: ' + dFechaFin );
			
			//Si se activo el cliente 
        	if (Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion){			
				Sol.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
				Sol.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;
        	}//Fin si Sol.TAM_Estatus__c == 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion
			//Si se rechazo el cliente 
        	if (Sol.TAM_Estatus__c == 'Rechazado' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Rechazado' && Sol.RecordTypeId == VaRtCLienteSolActivacion){			
				Sol.TAM_FechaVigenciaInicio__c = null; //Sol.TAM_FechaVigenciaInicio__c;
				Sol.TAM_FechaVigenciaFin__c = null; //Sol.TAM_FechaVigenciaFin__c;
        	}//Fin si Sol.TAM_Estatus__c == 'Rechazado' && Sol.RecordTypeId == VaRtCLienteSolActivacion
        	if (Sol.TAM_Estatus__c == 'Autorizado' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado' && (Sol.RecordTypeId == VaRtLeadSolFlot || Sol.RecordTypeId == VaRtLeadSolProg)){
				Sol.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
				Sol.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;
        	}//Fin si Sol.TAM_Estatus__c == 'Autorizado' && Sol.RecordTypeId != VaRtCLienteSolActivacion
	        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler TAM_FechaVigenciaInicio__c1: ' + Sol.TAM_FechaVigenciaInicio__c + ' TAM_FechaVigenciaFin__c1: ' + Sol.TAM_FechaVigenciaFin__c);
        	
        }//Fin del for para los reg de los solicitudes                            
    } 


   public static void actualizaDatosCandidato (List<TAM_SolicitudesParaAprobar__c> solicitudes, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato solicitudes: ' + solicitudes + ' mapsolicitudesOld: ' + mapsolicitudesOld);
        
        List<Lead> LleadUpd = new List<Lead>();
        List<Account> LAccountUpd = new List<Account>();
        List<TAM_SolicitudesParaAprobar__c> lTAM_SolicitudesParaAprobarUps = new List<TAM_SolicitudesParaAprobar__c>();   
        Map<String, String> mapNomCandIdCand = new Map<String, String>();
        List<Lead> lLead = new List<Lead>();
        
        //Recorre la lista de solicitudes
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	
        	//Ve si el estatus de la autorización es 'solicitudes'
        	if (Sol.TAM_Estatus__c == 'Rechazado' && (Sol.RecordTypeId == VaRtLeadSolFlot || Sol.RecordTypeId == VaRtLeadSolProg
        		|| Sol.RecordTypeId == VaRtLeadSolFlotSoloLec || Sol.RecordTypeId == VaRtLeadSolProgSoloLec ) && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Rechazado' ){ //&& mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Rechazado'
        		//Toma los datos del prospecto asociado y actualizalos
        		LleadUpd.add(new Lead(
        				id = Sol.TAM_Candidato__c,
        				TAM_EstatusAutorizacion__c = 'Rechazado',
        				TAM_ComentariosAutorizacionCliente__c = Sol.TAM_Comentarios__c,
        				TAM_EnviarAutorizacion__c = false,
        				Status = 'Rechazado',
						TAM_FechaVigenciaInicio__c = NULL,
						TAM_FechaVigenciaFin__c = NULL
        			)
        		);
        	}//Fin si Sol.TAM_Estatus__c = 'Rechazado'
			
        	if (Sol.TAM_Estatus__c == 'Rechazado' && Sol.RecordTypeId == VaRtCLienteSolActivacion){
        		//Toma los datos del prospecto asociado y actualizalos
        		LAccountUpd.add(new Account(
        				id = Sol.TAM_ClienteCorporativoRef__c,
        				TAM_EstatusCliente__c = 'Rechazado',
        				TAM_ComentariosAutorizacion__c = Sol.TAM_Comentarios__c,
						TAM_FechaVigenciaInicio__c = NULL,
						TAM_FechaVigenciaFin__c = NULL
        			)
        		);
        	}//Fin si Sol.TAM_Estatus__c = 'Rechazado'
				
        	//Ve si el estatus de la autorización es 'solicitudes'
        	if (Sol.TAM_Estatus__c == 'Autorizado' && (Sol.RecordTypeId == VaRtLeadSolFlot || Sol.RecordTypeId == VaRtLeadSolProg
        		|| Sol.RecordTypeId == VaRtLeadSolFlotSoloLec || Sol.RecordTypeId == VaRtLeadSolProgSoloLec ) ){ //&& mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado'  
        		//Llma al metodo para creo la cuenta corporativa si se trata de una flotilla
        		if (Sol.RecordTypeId == VaRtLeadSolFlot) //Sol.TAM_TipoCandidato__c == 'Flotilla'
        			if (!Test.isRunningTest())
        				creaClienteCorporativo(Sol, mapsolicitudesOld);
       			//Llma al metodo para creo la cuenta corporativa si se trata de una flotilla
        		if (Sol.RecordTypeId == VaRtLeadSolProg) // Sol.TAM_TipoCandidato__c == 'Programa'
        			if (!Test.isRunningTest())
        				creaClientePrograma(Sol, mapsolicitudesOld); 
        	}//Fin si Sol.TAM_Estatus__c = 'Rechazado'
        	        	
        }//Fin del for para los reg de los solicitudes
        
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato LleadUpd: ' + LleadUpd);
        //Ve si tiene algo la lista de lLead
        if(!LleadUpd.isEmpty())
        	if (!Test.isRunningTest())
        		List<Database.SaveResult> lSaveResultCand = Database.update(LleadUpd);
        		
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato LAccountUpd: ' + LAccountUpd);
        //Ve si tiene algo la lista de lLead
        if(!LAccountUpd.isEmpty())
        	if (!Test.isRunningTest())
        		List<Database.SaveResult> lSaveResultCand = Database.update(LAccountUpd);	

    } 

   public static void actualizaDatosClientePreautorizado (List<TAM_SolicitudesParaAprobar__c> solicitudes, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClientePreautorizado solicitudes: ' + solicitudes + ' mapsolicitudesOld: ' + mapsolicitudesOld);
        
        List<Lead> LleadUpd = new List<Lead>();
        List<TAM_SolicitudesParaAprobar__c> lTAM_SolicitudesParaAprobarUps = new List<TAM_SolicitudesParaAprobar__c>();   
        Map<String, String> mapNomCandIdCand = new Map<String, String>();
        List<Account> lAccountUpd = new List<Account>();
        Set<String> setIdCte = new Set<String>();
        Map<String, String> mapIdCteDatosCte = new Map<String, String>();
        
        //Recorre los reg de las solicutudes y toma el campo del TAM_ClienteCorporativoRef__c
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	if (Sol.TAM_ClienteCorporativoRef__c != null)
				setIdCte.add(Sol.TAM_ClienteCorporativoRef__c);			        
        }
        
        //Consulta el tipo de reg del cliente
        for (Account cliente : [Select Id, RecordTypeId From Account Where id IN :setIdCte]){
        	mapIdCteDatosCte.put(cliente.id, cliente.RecordTypeId);
        }
        
        //Recorre la lista de solicitudes
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	//Ve si el estatus de la autorización es 'solicitudes'
        	if (Sol.TAM_Estatus__c == 'Preautorizado' && Sol.RecordTypeId == VaRtCLienteSolPreautoriza	){ //&& mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Rechazado'
				//Un objeto para el cliente
				Account CteUpd = new Account(id = Sol.TAM_ClienteCorporativoRef__c);
				//Actualiza el tipo de reg del cliente a 
				if (mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPMNoVigente)
					CteUpd.recordTypeId = VaRtAccRegPMPreAut;
				if (mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPFNoVigente)
					CteUpd.recordTypeId = VaRtAccRegPFPreAut;					
        		//Toma los datos del prospecto asociado y actualizalos
        		lAccountUpd.add(CteUpd);
        	}//Fin si Sol.TAM_Estatus__c = 'Rechazado
        }//Fin del for para los reg de los solicitudes
        	        
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClientePreautorizado lAccountUpd: ' + lAccountUpd);
        //Ve si tiene algo la lista de lLead
        if(!lAccountUpd.isEmpty())
        	if (!Test.isRunningTest())        	
        		List<Database.SaveResult> lSaveResultCand = Database.update(lAccountUpd);
        	//System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClientePreautorizado lSaveResultCand: ' + lSaveResultCand);
    } 
    

   public static void actualizaDatosClienteActivado (List<TAM_SolicitudesParaAprobar__c> solicitudes, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado solicitudes: ' + solicitudes + ' mapsolicitudesOld: ' + mapsolicitudesOld);
        
        List<Lead> LleadUpd = new List<Lead>();
        List<TAM_SolicitudesParaAprobar__c> lTAM_SolicitudesParaAprobarUps = new List<TAM_SolicitudesParaAprobar__c>();   
        Map<String, String> mapNomCandIdCand = new Map<String, String>();
        List<Account> lAccountUpd = new List<Account>();
        Set<String> setIdCte = new Set<String>();
        Map<String, String> mapIdCteDatosCte = new Map<String, String>();
        Set<String> setIdProgramaRango = new Set<String>();
        Map<String, Integer> mapNameRangoIdProgramaRango = new Map<String, Integer>();
        Integer NoConsecutivoFinal = 0;
        
        //Recorre los reg de las solicutudes y toma el campo del TAM_ClienteCorporativoRef__c
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	if (Sol.TAM_ClienteCorporativoRef__c != null)
				setIdCte.add(Sol.TAM_ClienteCorporativoRef__c);
			if (Sol.TAM_ProgramaRangoPreautor__c != null)	
				setIdProgramaRango.add(Sol.TAM_ProgramaRangoPreautor__c);
            if (Sol.TAM_ProgramaRandoRef__c != null)   
                setIdProgramaRango.add(Sol.TAM_ProgramaRandoRef__c);
        }
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado setIdCte: ' + setIdCte);
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado setIdProgramaRango: ' + setIdProgramaRango);
        
        //Busca el rango asoaciado a setIdProgramaRango
        for (Rangos__c Rangos : [Select r.id, r.Name, r.DiasVigentes__c From Rangos__c r where Name IN:setIdProgramaRango]){
        	mapNameRangoIdProgramaRango.put(Rangos.Name, Integer.valueOf(Rangos.DiasVigentes__c));
        }
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado mapNameRangoIdProgramaRango: ' + mapNameRangoIdProgramaRango);
        
        //Consulta el tipo de reg del cliente
        for (Account cliente : [Select Id, RecordTypeId, RecordType.Name From Account Where id IN :setIdCte]){
        	mapIdCteDatosCte.put(cliente.id, cliente.RecordTypeId);
            System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado cliente: ' + cliente + ' RecordType.Name: ' + cliente.RecordType.Name);
        }
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado mapIdCteDatosCte: ' + mapIdCteDatosCte);
        
        //Consulta el total del lead asociados a cada setUsr para el mes actual
        for (Account clienteAct : [ Select id, TAM_NoConsecutivo__c, recordTypeId
            FROM Account Where (recordTypeId = :VaRtAccRegPMCC OR recordTypeId = :VaRtAccRegPFCC
            OR recordTypeId = :VaRtAccRegPMNoVigente OR recordTypeId = :VaRtAccRegPFNoVigente) 
            And TAM_NoConsecutivo__c != null
            Order by TAM_NoConsecutivo__c desc
            Limit 1 ]){
            //Mete a un mapa el total
            Integer NoConsecutivo = Integer.valueOf(clienteAct.TAM_NoConsecutivo__c);
            NoConsecutivoFinal = NoConsecutivo + 1;
            System.debug('EN getClientesCorporativos clienteAct.id: ' + clienteAct.id + ' NoConsecutivoFinal: ' + NoConsecutivoFinal + ' clienteAct.recordTypeId: ' + clienteAct.recordTypeId);
        }
        
        //Recorre la lista de solicitudes
        for(TAM_SolicitudesParaAprobar__c Sol: solicitudes){
        	//Ve si el estatus de la autorización es 'solicitudes'
        	if ( ((Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Activación')
                || (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c))     	 
        		&& Sol.RecordTypeId == VaRtCLienteSolActivacion	){ //&& mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Rechazado'
                System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado VA A ACTUALIZAR LOS DATOS DEL CLIENTE CORPORATIVO ...');

				//Un objeto para el cliente
				Account CteUpd = new Account(id = Sol.TAM_ClienteCorporativoRef__c);
				
				//Ve si ya tiene no Consecutivo el cliente : Sol.TAM_ClienteCorporativoRef__c
                Boolean bTienNoConse = false;
                Boolean blnPersonaMoral = false;
                Boolean blnActuaizaDatos = false;
                
                //Ve si ya tiene numero consetutivo esta cuenta
                for (Account cliente : [Select id, Name From Account where id = :Sol.TAM_ClienteCorporativoRef__c And TAM_NoConsecutivo__c != null]){
                    bTienNoConse = true;                    
                }
				
				//Actualiza el tipo de reg del cliente a 
				if (mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPM || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPMNoVigente
				    || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegCteCorp){
					CteUpd.recordTypeId = VaRtAccRegPMCC;
				    blnPersonaMoral = true;
                    System.debug('EN actualizaDatosClienteActivado VALIDACION VaRtAccRegPMCC');                           
				}//Fin si mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPM || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPMNoVigente
				if (mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPF || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPFNoVigente
				    || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPFCC){
					CteUpd.recordTypeId = VaRtAccRegPFCC;
                    System.debug('EN actualizaDatosClienteActivado VALIDACION VaRtAccRegPFCC');                           
				}//Fin si mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPF || mapIdCteDatosCte.get(Sol.TAM_ClienteCorporativoRef__c) == VaRtAccRegPFNoVigente
				
				//ACTUALIZA EL RESTO DE LOS DATOS DEL CLIENTE CORPORATIVO
				if (Sol.RecordTypeId == VaRtAccRegPM){
					CteUpd.Name = Sol.Name;
                    System.debug('EN actualizaDatosClienteActivado VALIDACION VaRtAccRegPM');				
				}//Fin si Sol.RecordTypeId == VaRtAccRegPM
				
				CteUpd.TAM_ProgramaRango__c = Sol.TAM_ProgramaRandoRef__c != null ? Sol.TAM_ProgramaRandoRef__c : null;
				CteUpd.TAM_GrupoCorporativo__c = Sol.TAM_GrupoCorporativoRef__c != null ? Sol.TAM_GrupoCorporativoRef__c : null ;
				
				CteUpd.DenominacionSocial__c = Sol.TAM_NombreComercial__c;
				CteUpd.TAM_NombreComercial__c = Sol.TAM_NombreComercial__c;
				CteUpd.Correo_Electronico__c = Sol.TAM_CorreoCorporativoRef__c;
				CteUpd.RFC__c = Sol.TAM_RFCRef__c;
				CteUpd.Phone = Sol.TAM_TelefonoCorporativoRef__c;
                CteUpd.Website = Sol.TAM_SitioWeb__c;
				//CteUpd.Sitio_Web__pc = Sol.TAM_SitioWeb__c;
	
				//Datos de la dirección del cliente
				CteUpd.BillingStreet = Sol.TAM_CalleRef__c;
				CteUpd.BillingPostalCode = Sol.TAM_CodigoPostalRef__c;
				CteUpd.Colonia__c = Sol.TAM_ColoniaRef__c;
				CteUpd.BillingCity = Sol.TAM_CiudadRef__c;
				CteUpd.BillingState = Sol.TAM_EstadoRef__c;
				CteUpd.BillingCountry = 'MÉXICO';
				
				//Datos del Representante Legal
				CteUpd.TAM_NombreRL__c = Sol.TAM_NombreRefRL__c;
				CteUpd.TAM_ApellidoPaternoRL__c = Sol.TAM_ApellidoPaternoRefRL__c;
				CteUpd.TAM_ApellidoMaternoRL__c = Sol.TAM_ApellidoMaternoRefRL__c;
				CteUpd.TAM_RFCRL__c = Sol.TAM_RFCRefRL__c;
				CteUpd.TAM_TelefonoRL__c = Sol.TAM_TelefonoRefRL__c;
				CteUpd.TAM_CorreoElectronicoRL__c = Sol.TAM_CorreoElectronicoRefRL__c;				

                Integer cIntDiasVigentes = 0;
                cIntDiasVigentes = Sol.TAM_ProgramaRandoRef__r.DiasVigentes__c != null ? Integer.valueOf(Sol.TAM_ProgramaRandoRef__r.DiasVigentes__c) : 0;
                //Inicializa las fecha de inicio y fin de la vigencia
                Date dFechaIni = Date.today();
                Date dFechaFin = Date.today();
                Date dtFechaActual = Date.today();
                    
                //Ve que fechas capturo en el campo de Sol.TAM_FechaVigenciaInicio__c y  Sol.TAM_FechaVigenciaFin__c;
                if (Sol.TAM_FechaVigenciaInicio__c == null && Sol.TAM_FechaVigenciaFin__c == null)
                    dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
                if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null){
                    dFechaIni = Sol.TAM_FechaVigenciaInicio__c; 
                    dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
                }//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null
                if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c != null){
                    dFechaIni = Sol.TAM_FechaVigenciaInicio__c; 
                    dFechaFin = Sol.TAM_FechaVigenciaFin__c; 
                }//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null             

                //Vamos a actualizar las fechas de vigencia solo si se esta autorizando
                if ( (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                    || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c) ){
                    System.debug('EN actualizaDatosClienteActivado VALIDACION 1');                           
                    blnActuaizaDatos = true;
                }//Fin si (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)

                //Si axtualiza los datos
                if (blnActuaizaDatos || Test.isRunningTest()){
                    dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual || Test.isRunningTest())
                        CteUpd.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if ( (dFechaFin < dtFechaActual && blnPersonaMoral) || Test.isRunningTest()){
                        CteUpd.TAM_EstatusCliente__c = 'Vencido';
                        CteUpd.recordTypeId = VaRtAccRegPMNoVigente;
                        System.debug('EN actualizaDatosClienteActivado VALIDACION 2');                           
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if ((dFechaFin < dtFechaActual && !blnPersonaMoral) || Test.isRunningTest()){
                        CteUpd.TAM_EstatusCliente__c = 'Vencido';
                        CteUpd.recordTypeId = VaRtAccRegPFNoVigente;
                        System.debug('EN actualizaDatosClienteActivado VALIDACION 3');
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                }//Fin si blnActuaizaDatos
                               
                //Actualiza el resto de los campos 
                CteUpd.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                CteUpd.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;
                CteUpd.TAM_FechaVigenciaFinOriginal__c = dFechaFin;                
                CteUpd.TAM_ComentariosAutorizacion__c = Sol.TAM_Comentarios__c;
                System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado CteUpd.TAM_FechaVigenciaInicio__c: ' + CteUpd.TAM_FechaVigenciaInicio__c + ' CteUpd.TAM_FechaVigenciaFin__c: ' + CteUpd.TAM_FechaVigenciaFin__c);                          
        		        		
        		//Actualiza el campo de NoConsecutivoFinal
        		if (!bTienNoConse)
        		  CteUpd.TAM_NoConsecutivo__c = NoConsecutivoFinal;
        		
		        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado CteUpd: ' + CteUpd);							
        		//Toma los datos del prospecto asociado y actualizalos
        		lAccountUpd.add(CteUpd);
        	}//Fin si Sol.TAM_Estatus__c = 'Rechazado
        }//Fin del for para los reg de los solicitudes
        	        
        System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado lAccountUpd: ' + lAccountUpd);
        //Ve si tiene algo la lista de lLead
        if(!lAccountUpd.isEmpty())
        	if (!Test.isRunningTest())
        		List<Database.SaveResult> lSaveResultCand = Database.update(lAccountUpd);
        		//System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosClienteActivado lSaveResultCand: ' + lSaveResultCand);

   		String sIdFrupoCtesCorp = '';
   		//ahora pon la colaboración para el nuevo cliente con el grupo de Clientes Corporativos
   		for (Group grupoPublico : [Select g.Name, g.Id From Group g
				where Name = 'Clientes Corporativos']){
    		sIdFrupoCtesCorp = grupoPublico.id;
    	}
   		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato sIdFrupoCtesCorp: ' + sIdFrupoCtesCorp);
      		
   		List<AccountShare> lCtesCorp = new List<AccountShare>();
   		for (Account objAccount : lAccountUpd){
       		lCtesCorp.add(new AccountShare(
    					UserOrGroupId = sIdFrupoCtesCorp,
    					AccountId = objAccount.id,
    					AccountAccessLevel = 'Edit',
    					OpportunityAccessLevel = 'None'
       			)
       		);       			
   		}//Fin del for para setIdClte
   		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato lCtesCorp: ' + lCtesCorp);
       		
        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
		List<Database.SaveResult> lDtbUpsRes = Database.insert(lCtesCorp, false);
		//Ve si hubo error
		for (Database.SaveResult objDtbUpsRes : lDtbUpsRes){
			if (!objDtbUpsRes.isSuccess())
	       		System.debug('Hubo un error a la hora de crear/Actualizar la colaboración con AccountShare ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
			if (objDtbUpsRes.isSuccess())
	       		System.debug('Los datos se Crearón/Actualizarón AccountShare CC con exito' + objDtbUpsRes.getId());
		}//Fin del for para lDtbUpsRes

    } 
    
    //Metodo que crea los datos del cliente corporativo cuando se trata de Flotilla
    public static void creaClienteCorporativo(TAM_SolicitudesParaAprobar__c Sol, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
   		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo Sol: ' + Sol);
   		List<Lead> LleadUpd = new List<Lead>();

		Set<String> setIdClte = new Set<String>();

		//Un SP para hacer el comit de toso en caso de alla habido errorres
	    SavePoint sp = Database.setSavePoint();
		try{

            Integer NoConsecutivoFinal = 0;
	        //Consulta el total del lead asociados a cada setUsr para el mes actual
	        for (Account clienteAct : [ Select id, TAM_NoConsecutivo__c
	            FROM Account Where (recordTypeId = :VaRtAccRegPMCC OR recordTypeId = :VaRtAccRegPFCC
	            OR recordTypeId = :VaRtAccRegPMNoVigente OR recordTypeId = :VaRtAccRegPFNoVigente) 
	            And TAM_NoConsecutivo__c != null
	            Order by TAM_NoConsecutivo__c desc
	            Limit 1 ]){
	            //Mete a un mapa el total
	            Integer NoConsecutivo = Integer.valueOf(clienteAct.TAM_NoConsecutivo__c);
	            NoConsecutivoFinal = NoConsecutivo + 1;
	            System.debug('EN creaClienteCorporativo clienteAct.id: ' + clienteAct.id + ' NoConsecutivoFinal: ' + NoConsecutivoFinal);
	        }
            			        		
        	Boolean bError = false;        		
        	Lead CandidatoPaso = new Lead();
        	//Consulta los datos de la direccion que agregaste para el cliente relacionado al corporativo
        	for (Lead candidato : [Select ID, Street, City, State, PostalCode, Country, TAM_CatalogoProgramas__c, 
        			TAM_CatalogoRangos__c, TAM_CatalogoProgramas__r.DiasVigentes__c, TAM_CatalogoRangos__r.DiasVigentes__c,
        			TAM_Calle__c, TAM_Colonia__c, TAM_CodigoPostal__c, TAM_Ciudad__c, TAM_Estado__c, TAM_Pais__c,
        			TAM_GrupoCorporativo__c, FWY_Tipo_de_persona__c, FirstName, LastName, FWY_ApellidoMaterno__c,
        			TAM_SinGrupoCorporativo__c
        			From Lead Where ID =: Sol.TAM_Candidato__c]){
        		CandidatoPaso = candidato; 
        	}
        	System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo CandidatoPaso: ' + CandidatoPaso);
        		
        	//String NombreCteCorporativo = Sol.TAM_ClienteCorporativo__c != NULL ? Sol.TAM_ClienteCorporativo__c : Sol.TAM_NombreNuevoClienteCorporativo__c;
			//System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo NombreCteCorporativo: ' + NombreCteCorporativo);
        	
			//Inicializa los datos de los dias de vigencia
        	Integer cIntDiasVigentes = 0;
   	    	cIntDiasVigentes = CandidatoPaso.TAM_CatalogoRangos__r.DiasVigentes__c != null ? Integer.valueOf(CandidatoPaso.TAM_CatalogoRangos__r.DiasVigentes__c) : 0;
			//Inicializa las fecha de inicio y fin de la vigencia
			Date dFechaIni = Date.today();
			Date dFechaFin = Date.today();
			
			Account cuentaCorpEncontreada;	
			Account cuentaRelac;
			    					
			//Los datos para el cliente relacionado 
			String NombreCteRel = Sol.Name ;
			//String NombreCteRel = Sol.TAM_RazonSocial__c != NULL ? Sol.TAM_RazonSocial__c : Sol.TAM_NombreComercial__c;
        	//Busca el nombre del cliente en la base de datos
			List<List<SObject>> searchListCtaRel = [FIND :NombreCteRel IN ALL FIELDS RETURNING Account(Name, RecordTypeId, TAM_IdExternoNombre__c)];
			System.debug('EN creaClienteCorporativo sNombreBuscarCons: ' + NombreCteRel + ' searchListCtaRel: ' + searchListCtaRel + ' searchListCtaRel.isEmpty(): ' + searchListCtaRel.isEmpty() + ' searchListCtaRel.size(): ' + searchListCtaRel.size());

			List<Account> searchAccountsRel = (List<Account>) searchListCtaRel[0];
			//Ve si encontraste cuentas
			if(!searchAccountsRel.isEmpty()){
				//Recorre la lista de reg de las cuentas que fueron encontradas
				for (Account Cuenta : searchAccountsRel){
					System.debug('EN creaClienteCorporativo ENCONTRO COINCIDENCIAS PARA sNombreBuscarCons2: ' + Cuenta);
					//Ve si el campo de Name es igula al de NombreCteRel
					if (Cuenta.Name == NombreCteRel){	
						System.debug('EN creaClienteCorporativo YA ENCONTRO LA CUENTA...');
						cuentaRelac = Cuenta;
						Break;
					}//Fin si Cuenta.Name == NombreCteRel
				}//Fin del for para searchAccountsRel			
			}//Fin si 	!searchAccountsRel.isEmpty()
			System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo cuentaRelac: ' + cuentaRelac);

			//Si no existe el cliente corporativo y tampoco el cliente relacionado
			if (cuentaRelac == null){
				System.debug('EN creaClienteCorporativo no existe la cuenta relacionada.');							
				//Actualiza los datos del cliente relacioando
				cuentaRelac = new Account();
			}//No existe el cliente entonces creamos una cuenta
				        	
			//Ya creamos el regirtro del cliente relacionado
			if (cuentaRelac != null){
				System.debug('EN creaClienteCorporativo no existe la cuenta corpo y no existe la cuenta relaci...');
				
				Boolean bTienNoConse = false;
				Boolean blnPersonaMoral = false;
				Boolean blnActuaizaDatos = false;
				
				//Ve si ya tiene numero consetutivo esta cuenta
				for (Account cliente : [Select id, Name From Account where id = :cuentaRelac.id And TAM_NoConsecutivo__c != null]){
                    bTienNoConse = true;				    
				}
				
				//Se trata de persona fisica										
				if (CandidatoPaso.FWY_Tipo_de_persona__c == 'Person física' || CandidatoPaso.FWY_Tipo_de_persona__c == 'Fisica con actividad empresarial' || Test.isRunningTest()){
	       			cuentaRelac.FirstName = CandidatoPaso.FirstName != null ? CandidatoPaso.FirstName.toUpperCase() : null;
	       			cuentaRelac.LastName = CandidatoPaso.LastName != null ? CandidatoPaso.LastName.toUpperCase() : null;
	       			cuentaRelac.Apellido_Paterno__c = CandidatoPaso.FWY_ApellidoMaterno__c != null ? CandidatoPaso.FWY_ApellidoMaterno__c.toUpperCase() : null;
	       			cuentaRelac.TAM_IdExternoNombre__c = cuentaRelac.FirstName + ' ' + cuentaRelac.LastName + ' ' + cuentaRelac.Apellido_Paterno__c;	       			
	       			cuentaRelac.recordTypeId = VaRtAccRegPFCC;
				}//Fin si CandidatoPaso.FWY_Tipo_de_persona__c == 'Person física'
				//Se trata de persona Moral
				if (CandidatoPaso.FWY_Tipo_de_persona__c == 'Persona moral'){
					cuentaRelac.Name = Sol.TAM_RazonSocial__c != NULL ? Sol.TAM_RazonSocial__c.toUpperCase() : (Sol.TAM_NombreComercial__c != null ? Sol.TAM_NombreComercial__c.toUpperCase() : null);
	       			cuentaRelac.TAM_IdExternoNombre__c = cuentaRelac.Name;
					cuentaRelac.recordTypeId = VaRtAccRegPMCC;
					blnPersonaMoral = true;
				}
                System.debug('EN creaClienteCorporativo cuentaRelac: ' + cuentaRelac);                           
				
                //Inicializa el canpo del TAM_DistribuidorCC__c
                cuentaRelac.TAM_DistribuidorCC__c = getDistribuidor(Sol.OwnerId);
				
				//Ve que fechas capturo en el campo de Sol.TAM_FechaVigenciaInicio__c y  Sol.TAM_FechaVigenciaFin__c;
				if (Sol.TAM_FechaVigenciaInicio__c == null && Sol.TAM_FechaVigenciaFin__c == null)
					dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
				if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null){
					dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
					dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
				}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null
				if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c != null){
					dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
					dFechaFin = Sol.TAM_FechaVigenciaFin__c; 
				}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null				
                System.debug('EN creaClienteCorporativo ANTE DE LA VALIDACION 1 dFechaIni: ' + dFechaIni + ' dFechaFin: ' + dFechaFin);

                //Vamos a actualizar las fechas de vigencia solo si se esta autorizando
                if ( ( Sol.TAM_Estatus__c == 'Autorizado' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado')
                    || (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                    || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c)
                    ){
                    System.debug('EN creaClienteCorporativo VALIDACION 1');
                    /*Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual)
                        cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if (dFechaFin < dtFechaActual && blnPersonaMoral){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = VaRtAccRegPMNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if (dFechaFin < dtFechaActual && !blnPersonaMoral){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = VaRtAccRegPFNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                    cuentaRelac.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaRelac.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
                    blnActuaizaDatos = true;
                }//Fin si Sol.TAM_Estatus__c == 'Autorizado' mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado'
 
	            //Si se activo el cliente 
	            if (Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion){            
                    System.debug('EN creaClienteCorporativo VALIDACION 2');                           
                    /*Date dtFechaActual = Date.today();
	                //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
	                if (dFechaFin >= dtFechaActual)
	                    cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
	                //Es una persona moral
	                if (dFechaFin < dtFechaActual && blnPersonaMoral){
	                    cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
	                    //cuentaRelac.recordTypeId = VaRtAccRegPMNoVigente;
	                }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
	                //Es una persona fsica
	                if (dFechaFin < dtFechaActual && !blnPersonaMoral){
	                    cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
	                    //cuentaRelac.recordTypeId = VaRtAccRegPFNoVigente;
	                }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                    cuentaRelac.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaRelac.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
	               blnActuaizaDatos = true;
	            }//Fin si Sol.TAM_Estatus__c == 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion 

                //Vamos a actualizar las fechas de vigencia solo si se esta autorizando
                if ( ( Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c == 'Activación')
                    || (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                    || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c)
                    ){
                    System.debug('EN creaClienteCorporativo VALIDACION 3');                           
                    /*Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual)
                        cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if (dFechaFin < dtFechaActual && blnPersonaMoral){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = VaRtAccRegPMNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if (dFechaFin < dtFechaActual && !blnPersonaMoral){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = VaRtAccRegPFNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                    cuentaRelac.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaRelac.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
                    blnActuaizaDatos = true;
                }//Fin si ( Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c == 'Activación')

			    /*public static String VaRtAccRegPMCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();
			    public static String VaRtAccRegPFCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo CP').getRecordTypeId();			
			    public static String VaRtAccRegPMNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral No Vigente').getRecordTypeId();
			    public static String VaRtAccRegPFNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica No Vigente').getRecordTypeId();*/

                //Si axtualiza los datos
                if (blnActuaizaDatos || Test.isRunningTest()){
                    Date dtFechaActual = Date.today();
                    System.debug('EN creaClienteCorporativo DESPUES DE LA VALIDACION 3 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);                           
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual || Test.isRunningTest()){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vigente';
                        cuentaRelac.recordTypeId = (cuentaRelac.recordTypeId == VaRtAccRegPMNoVigente || cuentaRelac.recordTypeId == VaRtAccRegPMCC ) ? VaRtAccRegPMCC : VaRtAccRegPFCC;
                        System.debug('EN creaClienteCorporativo VALIDACION 4 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);                           
                    }//Fin si dFechaFin >= dtFechaActual || Test.isRunningTest()
                    //Es una persona moral
                    if ( (dFechaFin < dtFechaActual && blnPersonaMoral) || Test.isRunningTest()){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = (cuentaRelac.recordTypeId == VaRtAccRegPMCC || cuentaRelac.recordTypeId == VaRtAccRegPMNoVigente ) ? VaRtAccRegPMNoVigente : VaRtAccRegPFNoVigente;
                        System.debug('EN creaClienteCorporativo VALIDACION 5 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if ((dFechaFin < dtFechaActual && !blnPersonaMoral) || Test.isRunningTest()){
                        cuentaRelac.TAM_EstatusCliente__c = 'Vencido';
                        cuentaRelac.recordTypeId = (cuentaRelac.recordTypeId == VaRtAccRegPFCC || cuentaRelac.recordTypeId == VaRtAccRegPFNoVigente ) ? VaRtAccRegPFNoVigente : VaRtAccRegPMNoVigente;
                        System.debug('EN creaClienteCorporativo VALIDACION 6 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    cuentaRelac.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaRelac.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;
                    cuentaRelac.TAM_FechaVigenciaFinOriginal__c = dFechaFin;
                }//Fin si blnActuaizaDatos
                System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo cuentaRelac: ' + cuentaRelac);
				
				TAM_GrupoCorporativo__c objGrupo = new TAM_GrupoCorporativo__c();
				//Bisca el cliente coprotarivo dependiendo de TAM_SinGrupoCorporativo__c
				if (CandidatoPaso.TAM_SinGrupoCorporativo__c){
					for (TAM_GrupoCorporativo__c grupo : [Select id, Name From TAM_GrupoCorporativo__c Where Name =: 'SIN GRUPO CORPORATIVO']){
						objGrupo = grupo;
					}
				}
				System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClienteCorporativo objGrupo: ' + objGrupo);
				
				//Asigna el grupo correcto
				if (CandidatoPaso.TAM_SinGrupoCorporativo__c)
					cuentaRelac.TAM_GrupoCorporativo__c = objGrupo.id;
				if (!CandidatoPaso.TAM_SinGrupoCorporativo__c)
					cuentaRelac.TAM_GrupoCorporativo__c = Sol.TAM_GrupoCorporativoRef__c; //TAM_GrupoCorporativo__c;	
				
				//Ve si la solicitud ya tiene un grupo Corpo en Sol.TAM_GrupoCorporativoRef__c
				if (Sol.TAM_GrupoCorporativoRef__c != null)
                    cuentaRelac.TAM_GrupoCorporativo__c = Sol.TAM_GrupoCorporativoRef__c;
                    				    			
				cuentaRelac.BillingStreet = Sol.TAM_CalleRef__c != null ? Sol.TAM_CalleRef__c.toUpperCase() : null; //TAM_Calle__c
				cuentaRelac.BillingPostalCode = Sol.TAM_CodigoPostalRef__c != null ? Sol.TAM_CodigoPostalRef__c.toUpperCase() : null; //TAM_CodigoPostal__c
				cuentaRelac.Colonia__c = Sol.TAM_ColoniaRef__c != null ? Sol.TAM_ColoniaRef__c.toUpperCase() : null; //TAM_Colonia__c
				cuentaRelac.BillingCity = Sol.TAM_CiudadRef__c != null ? Sol.TAM_CiudadRef__c.toUpperCase() : null; //TAM_Ciudad__c
				cuentaRelac.BillingState = Sol.TAM_EstadoRef__c != null ? Sol.TAM_EstadoRef__c.toUpperCase() : null; //TAM_Estado__c
				cuentaRelac.BillingCountry = CandidatoPaso.TAM_Pais__c != null ? CandidatoPaso.TAM_Pais__c.toUpperCase() : null;				
				
				cuentaRelac.Correo_Electronico__c = Sol.TAM_CorreoCorporativoRef__c != null ? Sol.TAM_CorreoCorporativoRef__c : null; //TAM_CorreoElectronico__c
				cuentaRelac.Phone = Sol.TAM_TelefonoCorporativoRef__c != null ? Sol.TAM_TelefonoCorporativoRef__c.toUpperCase() : null; //TAM_TelefonoCuenta__c
				cuentaRelac.RFC__c = Sol.TAM_RFCRef__c != null ? Sol.TAM_RFCRef__c.toUpperCase() : null; //TAM_RFC__c
                cuentaRelac.Website = Sol.TAM_SitioWeb__c;
                //cuentaRelac.Sitio_Web__pc = Sol.TAM_SitioWeb__c;
				
				//Aqui los datos del representante Legal
				cuentaRelac.TAM_NombreRL__c = Sol.TAM_NombreRefRL__c != null ? Sol.TAM_NombreRefRL__c.toUpperCase() : null; //TAM_NombreRL__c
				cuentaRelac.TAM_ApellidoPaternoRL__c = Sol.TAM_ApellidoPaternoRefRL__c != null ? Sol.TAM_ApellidoPaternoRefRL__c.toUpperCase() : null; //TAM_ApellidoPaternoRL__c
				cuentaRelac.TAM_ApellidoMaternoRL__c = Sol.TAM_ApellidoMaternoRefRL__c != null ? Sol.TAM_ApellidoMaternoRefRL__c.toUpperCase() : null; //TAM_ApellidoMaternoRL__c
				cuentaRelac.TAM_RFCRL__c = Sol.TAM_RFCRefRL__c != null ? Sol.TAM_RFCRefRL__c.toUpperCase() : null; //TAM_RFCRL__c
				cuentaRelac.TAM_CorreoElectronicoRL__c = Sol.TAM_CorreoElectronicoRefRL__c != null ? Sol.TAM_CorreoElectronicoRefRL__c.toUpperCase() : null; //TAM_CorreoElectronicoRL__c
				cuentaRelac.TAM_TelefonoRL__c = Sol.TAM_TelefonoRefRL__c != null ? Sol.TAM_TelefonoRefRL__c.toUpperCase() : null; //TAM_TelefonoRL__c
				cuentaRelac.TAM_DireccionRL__c = Sol.TAM_DireccionRL__c != null ? Sol.TAM_DireccionRL__c.toUpperCase() : null;

				cuentaRelac.TAM_ProgramaRango__c = Sol.TAM_ProgramaRandoRef__c;
				cuentaRelac.TAM_NombreComercial__c = Sol.TAM_NombreComercial__c != null ? Sol.TAM_NombreComercial__c.toUpperCase() : null;
				cuentaRelac.DenominacionSocial__c = Sol.TAM_RazonSocial__c != null ? Sol.TAM_RazonSocial__c.toUpperCase() : null;
				cuentaRelac.TAM_TipoPersonaProspecto__c = Sol.TAM_TipoPersona__c != null ? Sol.TAM_TipoPersona__c.toUpperCase() : null;		

				System.debug('EN creaClienteCorporativo cuentaRelac: ' + cuentaRelac);

                System.debug('EN creaClienteCorporativo NoConsecutivoFinal: ' + NoConsecutivoFinal);
                //Actualiza el campo de NoConsecutivoFinal
                if (!bTienNoConse)
                    cuentaRelac.TAM_NoConsecutivo__c = NoConsecutivoFinal;
                System.debug('EN creaClienteCorporativo cuentaRelac: ' + cuentaRelac);
					
				//Actualiza los datos del cliente relacionado 
				if (!Test.isRunningTest()){
					//Database.SaveResult dtSV = Database.insert(cuentaRelac);
					Database.UpsertResult dtSV = Database.upsert(cuentaRelac, Account.TAM_IdExternoNombre__c, false);					
					if (!dtSV.success){
						bError = true;
						System.debug('EN creaClienteCorporativo ERROR A LA HORA DE CREAR EL REG DEL cuentaRelac: ' + dtSV.getErrors()[0].getMessage());
					}//Fin si !dtSV.success
       				if (dtSV.isSuccess())
       					setIdClte.add(dtSV.getId());
				}//Fin si !Test.isRunningTest()
			
			}//Fin si cuentaCorpEncontreada != null
				 		
        	//Toma los datos del prospecto asociado y actualizalos
        	LleadUpd.add(new Lead(
        			id = Sol.TAM_Candidato__c,
        			TAM_EstatusAutorizacion__c = 'Autorizado',
        			TAM_ComentariosAutorizacionCliente__c = Sol.TAM_Comentarios__c,
        			RecordTypeId = !bError ? VaRtLeadCteCreado : VaRtLeadEstAuto,
        			Status = !bError ? 'Cliente Creado' : 'Autorizado',
        			TAM_FechaVigenciaInicio__c = dFechaIni, //Sol.TAM_FechaVigenciaInicio__c,
        			TAM_FechaVigenciaFin__c = dFechaFin //Sol.TAM_FechaVigenciaFin__c
        			//,Rango__c = Sol.TAM_RangoFinall__c
        		)
        	);
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato LleadUpd: ' + LleadUpd);

        	//Ve si tiene algo la lista de lLead
       		if(!LleadUpd.isEmpty()){
       			if (!Test.isRunningTest()){
        			List<Database.SaveResult> lSaveResultCand = Database.update(LleadUpd, false);
        			for (Database.SaveResult objDtbUpsRes : lSaveResultCand){
                        if (!objDtbUpsRes.isSuccess())
                            System.debug('Hubo un error a la hora de crear/Actualizar los datos del Lead ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
        			}//Fin del for para lSaveResultCand
       			}//Fin si !Test.isRunningTest()
       		}//Fin del !LleadUpd.isEmpty()
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato setIdClte: ' + setIdClte);
       		
       		String sIdFrupoCtesCorp = '';
       		//ahora pon la colaboración para el nuevo cliente con el grupo de Clientes Corporativos
       		for (Group grupoPublico : [Select g.Name, g.Id From Group g
					where Name = 'Clientes Corporativos']){
	    		sIdFrupoCtesCorp = grupoPublico.id;
	    	}
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato sIdFrupoCtesCorp: ' + sIdFrupoCtesCorp);
       		
       		List<AccountShare> lCtesCorp = new List<AccountShare>();
       		for (String setIdCltePaso : setIdClte){
	       		lCtesCorp.add(new AccountShare(
	    					UserOrGroupId = sIdFrupoCtesCorp,
	    					AccountId = setIdCltePaso,
	    					AccountAccessLevel = 'Edit',
	    					OpportunityAccessLevel = 'None'
	       			)
	       		);       			
       		}//Fin del for para setIdClte
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato lCtesCorp: ' + lCtesCorp);
       		
	        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
			List<Database.SaveResult> lDtbUpsRes = Database.insert(lCtesCorp, false);
			//Ve si hubo error
			for (Database.SaveResult objDtbUpsRes : lDtbUpsRes){
				if (!objDtbUpsRes.isSuccess())
		       		System.debug('Hubo un error a la hora de crear/Actualizar la colaboración con AccountShare ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
				if (objDtbUpsRes.isSuccess())
		       		System.debug('Los datos se Crearón/Actualizarón AccountShare CC con exito' + objDtbUpsRes.getId());
			}//Fin del for para lDtbUpsRes       		
       		
		}catch(Exception ex){
			System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler actualizaDatosCandidato ERROR: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
			//Alica el rollback
			Database.rollback(sp);
		}
    
		//HECHA PARA ATRAS TODO PORQUE ES UNA PRUEBA
		//Database.rollback(sp);
    	
    }
    

    //Metodo que crea los datos del cliente corporativo cuando se trata de Flotilla
    public static void creaClientePrograma(TAM_SolicitudesParaAprobar__c Sol, Map<id,TAM_SolicitudesParaAprobar__c> mapsolicitudesOld){
		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma Sol: ' + Sol);
		List<Lead> LleadUpd = new List<Lead>();
		Set<String> setIdClte = new Set<String>();

		//Un SP para hacer el comit de toso en caso de alla habido errorres
	    SavePoint sp = Database.setSavePoint();
		try{

            Integer NoConsecutivoFinal = 0;
            //Consulta el total del lead asociados a cada setUsr para el mes actual
            for (Account clienteAct : [ Select id, TAM_NoConsecutivo__c
                FROM Account Where (recordTypeId = :VaRtAccRegPMCC OR recordTypeId = :VaRtAccRegPFCC
                OR recordTypeId = :VaRtAccRegPMNoVigente OR recordTypeId = :VaRtAccRegPFNoVigente) 
                And TAM_NoConsecutivo__c != null
                Order by TAM_NoConsecutivo__c desc
                Limit 1 ]){
                //Mete a un mapa el total
                Integer NoConsecutivo = Integer.valueOf(clienteAct.TAM_NoConsecutivo__c);
                NoConsecutivoFinal = NoConsecutivo + 1;
                System.debug('EN getClientesCorporativos clienteAct.id: ' + clienteAct.id + ' NoConsecutivoFinal: ' + NoConsecutivoFinal);
            }
			
        	Boolean bError = false;        		
        	Lead CandidatoPaso = new Lead();
        	//Consulta los datos de la direccion que agregaste para el cliente relacionado al corporativo
        	for (Lead candidato : [Select ID, Street, City, State, PostalCode, Country, TAM_CatalogoProgramas__c, 
        			TAM_CatalogoRangos__c, TAM_CatalogoProgramas__r.DiasVigentes__c, TAM_CatalogoRangos__r.DiasVigentes__c,
        			TAM_Calle__c, TAM_Colonia__c, TAM_CodigoPostal__c, TAM_Ciudad__c, TAM_Estado__c, TAM_Pais__c,
        			TAM_GrupoCorporativo__c, FWY_Tipo_de_persona__c, FirstName, LastName, FWY_ApellidoMaterno__c,
        			TAM_SinGrupoCorporativo__c
        		From Lead Where ID =: Sol.TAM_Candidato__c]){
        		CandidatoPaso = candidato; 
        	}        	
        	System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma CandidatoPaso: ' + CandidatoPaso);

			//Inicializa los datos de los dias de vigencia
        	Integer cIntDiasVigentes = 0;
   	    	cIntDiasVigentes = CandidatoPaso.TAM_CatalogoProgramas__r.DiasVigentes__c != null ? Integer.valueOf(CandidatoPaso.TAM_CatalogoProgramas__r.DiasVigentes__c) : 0;
			//Inicializa las fecha de inicio y fin de la vigencia
			Date dFechaIni = Date.today();
			Date dFechaFin = Date.today();
        	
        	String sNombreCtePrograma = Sol.Name ;
	       	//String NombreCteCorporativo = Sol.TAM_ClienteCorporativo__c != NULL ? Sol.TAM_ClienteCorporativo__c : Sol.TAM_NombreNuevoClienteCorporativo__c;
			System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma sNombreCtePrograma: ' + sNombreCtePrograma);
        		
        	//Busca el nombre del cliente Corporativo en la base de datos
			List<List<SObject>> searchListCtaCorp = [FIND :sNombreCtePrograma IN ALL FIELDS RETURNING Account(Name, Apellido_Paterno__c, RecordTypeId, TAM_IdExternoNombre__c)];
			System.debug('EN creaClientePrograma sNombreBuscarCons: ' + sNombreCtePrograma + ' searchListCtaCorp: ' + searchListCtaCorp + ' searchListCtaCorp.isEmpty(): ' + searchListCtaCorp.isEmpty() + ' searchListCtaCorp.size(): ' + searchListCtaCorp.size());
			Account cuentaPersonalEncontreada;
				
			 List<Account> searchAccountsCorp = (List<Account>) searchListCtaCorp[0];
			 //Ve si encontraste cuentas
			 if(!searchAccountsCorp.isEmpty()){
				//Recorre la lista de reg de las cuentas que fueron encontradas
				for (Account Cuenta : searchAccountsCorp){
					String sNombreCompleto = Cuenta.Name + ' ' + (Cuenta.Apellido_Paterno__c != null ? Cuenta.Apellido_Paterno__c : '');
					System.debug('EN creaClientePrograma ENCONTRO COINCIDENCIAS PARA sNombreBuscarCons2 sNombreCompleto: ' + sNombreCompleto + ' Cuenta: ' + Cuenta + ' VaRtAccRegPFCC: ' + VaRtAccRegPFCC);
					//Ve si el campo de Name es igula al de sNombreCtePrograma
					if (sNombreCompleto == sNombreCtePrograma){	
						System.debug('EN creaClientePrograma YA ENCONTRO LA CUENTA...');
						//cuentaPersonalEncontreada = Cuenta;
						cuentaPersonalEncontreada = new Account(id = Cuenta.id);
						Break;
					}//Fin si Cuenta.Name == sNombreCtePrograma
				}//Fin del for para searchAccountsCorp			
			}//Fin si 	!searchAccountsCorp.isEmpty()
			System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma cuentaPersonalEncontreada: ' + cuentaPersonalEncontreada);

			//Si no existe el cliente corporativo y tampoco el cliente relacionado
			if (cuentaPersonalEncontreada == null){
				System.debug('EN creaClientePrograma no existe la cuenta relacionada.');							
				//Actualiza los datos del cliente relacioando
				cuentaPersonalEncontreada = new Account();
			}//No existe el cliente entonces creamos una cuenta
				        									
			//Ya creamos el regirtro del cliente relacionado
			if (cuentaPersonalEncontreada != null){
				System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma NO EXISTE EL CLIENTE....');

                Boolean bTienNoConse = false;
                Boolean blnPersonaMoral = false;
                Boolean blnActuaizaDatos = false; 
                
                //Ve si ya tiene numero consetutivo esta cuenta
                for (Account cliente : [Select id, Name From Account where id = :cuentaPersonalEncontreada.id And TAM_NoConsecutivo__c != null]){
                    bTienNoConse = true;                    
                }
								
				//CandidatoPaso.FWY_Tipo_de_persona__c == 'Person física' || CandidatoPaso.FWY_Tipo_de_persona__c == 'Fisica con actividad empresarial'
				if (CandidatoPaso.FWY_Tipo_de_persona__c == 'Person física' || CandidatoPaso.FWY_Tipo_de_persona__c == 'Fisica con actividad empresarial' || Test.isRunningTest()){
	       			cuentaPersonalEncontreada.FirstName = CandidatoPaso.FirstName != null ? CandidatoPaso.FirstName.toUpperCase() : null;
	       			cuentaPersonalEncontreada.LastName = CandidatoPaso.LastName != null ? CandidatoPaso.LastName.toUpperCase() : null;
	       			cuentaPersonalEncontreada.Apellido_Paterno__c = CandidatoPaso.FWY_ApellidoMaterno__c != null ? CandidatoPaso.FWY_ApellidoMaterno__c.toUpperCase() : null;
	       			cuentaPersonalEncontreada.TAM_IdExternoNombre__c = cuentaPersonalEncontreada.FirstName + ' ' + cuentaPersonalEncontreada.LastName + ' ' + cuentaPersonalEncontreada.Apellido_Paterno__c;
                    cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPFCC;
                    cuentaPersonalEncontreada.Website = Sol.TAM_SitioWeb__c;
				}//Fin si CandidatoPaso.FWY_Tipo_de_persona__c == 'Person física' || CandidatoPaso.FWY_Tipo_de_persona__c == 'Fisica con actividad empresarial;
				
				//CandidatoPaso.FWY_Tipo_de_persona__c == 'Persona moral'
				if (CandidatoPaso.FWY_Tipo_de_persona__c == 'Persona moral'){
					cuentaPersonalEncontreada.Name = Sol.TAM_RazonSocial__c != NULL ? Sol.TAM_RazonSocial__c.toUpperCase() : (Sol.TAM_NombreComercial__c != null ? Sol.TAM_NombreComercial__c.toUpperCase() : null);
					cuentaPersonalEncontreada.TAM_IdExternoNombre__c = cuentaPersonalEncontreada.Name;
					cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPMCC;
                    cuentaPersonalEncontreada.Website = Sol.TAM_SitioWeb__c;
                    blnPersonaMoral = true;
				}//Fin si CandidatoPaso.FWY_Tipo_de_persona__c == 'Persona moral'

                //Inicializa el canpo del TAM_DistribuidorCC__c
                cuentaPersonalEncontreada.TAM_DistribuidorCC__c = getDistribuidor(Sol.OwnerId);
				
				//Ve que fechas capturo en el campo de Sol.TAM_FechaVigenciaInicio__c y  Sol.TAM_FechaVigenciaFin__c;
				if (Sol.TAM_FechaVigenciaInicio__c == null && Sol.TAM_FechaVigenciaFin__c == null)
					dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
				if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null){
					dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
					dFechaFin = dFechaIni.addDays(cIntDiasVigentes); 
				}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null
				if (Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c != null){
					dFechaIni = Sol.TAM_FechaVigenciaInicio__c;	
					dFechaFin = Sol.TAM_FechaVigenciaFin__c; 
				}//Fin si Sol.TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaFin__c == null				
				
                //Vamos a actualizar las fechas de vigencia solo si se esta autorizando
                if ( (Sol.TAM_Estatus__c == 'Autorizado' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado')
                    || (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                    || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c)                    
                    ){
                    System.debug('EN creaClientePrograma VALIDACION 1');
                    /*Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual)
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if (dFechaFin < dtFechaActual && blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPMNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if (dFechaFin < dtFechaActual && !blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPFNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    cuentaPersonalEncontreada.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaPersonalEncontreada.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
                    blnActuaizaDatos = true; 
                }//Fin si Sol.TAM_Estatus__c == 'Autorizado' mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Autorizado'

                //Si se activo el cliente 
                if (Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c != 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion){            
                    System.debug('EN creaClientePrograma VALIDACION 2');                           
                    /*Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual)
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if (dFechaFin < dtFechaActual && blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPMNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if (dFechaFin < dtFechaActual && !blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPFNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    cuentaPersonalEncontreada.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaPersonalEncontreada.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
                    blnActuaizaDatos = true; 
                }//Fin si Sol.TAM_Estatus__c == 'Activación' && Sol.RecordTypeId == VaRtCLienteSolActivacion 

                //Vamos a actualizar las fechas de vigencia solo si se esta autorizando
                if ( ( Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c == 'Activación')
                    || (Sol.TAM_FechaVigenciaInicio__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c != null && Sol.TAM_FechaVigenciaInicio__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaInicio__c)
                    || (Sol.TAM_FechaVigenciaFin__c != null && mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c != null && Sol.TAM_FechaVigenciaFin__c != mapsolicitudesOld.get(Sol.id).TAM_FechaVigenciaFin__c)
                    ){
                    System.debug('EN creaClientePrograma VALIDACION 3');                           
                    /*Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual)
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    //Es una persona moral
                    if (dFechaFin < dtFechaActual && blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPMNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if (dFechaFin < dtFechaActual && !blnPersonaMoral){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = VaRtAccRegPFNoVigente;
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    cuentaPersonalEncontreada.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaPersonalEncontreada.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;*/
                    blnActuaizaDatos = true; 
                }//Fin si  ( Sol.TAM_Estatus__c == 'Activación' && mapsolicitudesOld.get(Sol.id).TAM_Estatus__c == 'Activación'
                
                //Si axtualiza los datos
                if (blnActuaizaDatos || Test.isRunningTest()){
                    Date dtFechaActual = Date.today();
                    //Ve que la fecha de fin de vigencia sea mayor o igual a la fech Actual
                    if (dFechaFin >= dtFechaActual || Test.isRunningTest()){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                        cuentaPersonalEncontreada.recordTypeId = (cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPMNoVigente || cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPMCC ) ? VaRtAccRegPMCC : VaRtAccRegPFCC;
                        System.debug('EN creaClientePrograma VALIDACION 4 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);                           
                    }//Fin si dFechaFin >= dtFechaActual || Test.isRunningTest()
                    //Es una persona moral
                    if ( (dFechaFin < dtFechaActual && blnPersonaMoral) || Test.isRunningTest()){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = (cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPMCC || cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPMNoVigente ) ? VaRtAccRegPMNoVigente : VaRtAccRegPFNoVigente;
                        System.debug('EN creaClientePrograma VALIDACION 5 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);                    
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPMCC || CteUpd.recordTypeId == VaRtAccRegPMNoVigente)
                    //Es una persona fsica
                    if ((dFechaFin < dtFechaActual && !blnPersonaMoral) || Test.isRunningTest()){
                        cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vencido';
                        cuentaPersonalEncontreada.recordTypeId = (cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPFCC || cuentaPersonalEncontreada.recordTypeId == VaRtAccRegPFNoVigente ) ? VaRtAccRegPFNoVigente : VaRtAccRegPMNoVigente;
                        System.debug('EN creaClientePrograma VALIDACION 6 dFechaFin: ' + dFechaFin + ' dtFechaActual: ' + dtFechaActual);
                    }//Fin si dFechaFin < dtFechaActual && (CteUpd.recordTypeId == VaRtAccRegPFCC || CteUpd.recordTypeId == VaRtAccRegPFNoVigente)
                    //cuentaPersonalEncontreada.TAM_EstatusCliente__c = 'Vigente';
                    cuentaPersonalEncontreada.TAM_FechaVigenciaInicio__c = dFechaIni; //Sol.TAM_FechaVigenciaInicio__c;
                    cuentaPersonalEncontreada.TAM_FechaVigenciaFin__c = dFechaFin; //Sol.TAM_FechaVigenciaFin__c;  
                    cuentaPersonalEncontreada.TAM_FechaVigenciaFinOriginal__c = dFechaFin;
                }//Fin si blnActuaizaDatos
                System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma cuentaPersonalEncontreada: ' + cuentaPersonalEncontreada);    				
				
				TAM_GrupoCorporativo__c objGrupo = new TAM_GrupoCorporativo__c();
				//Bisca el cliente coprotarivo dependiendo de TAM_SinGrupoCorporativo__c
				if (CandidatoPaso.TAM_SinGrupoCorporativo__c){
					for (TAM_GrupoCorporativo__c grupo : [Select id, Name From TAM_GrupoCorporativo__c Where Name =: 'SIN GRUPO CORPORATIVO']){
						objGrupo = grupo;
					}
				}
				System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma objGrupo: ' + objGrupo);
				
				//Asigna el grupo correcto
				if (CandidatoPaso.TAM_SinGrupoCorporativo__c)
					cuentaPersonalEncontreada.TAM_GrupoCorporativo__c = objGrupo.id;
				if (!CandidatoPaso.TAM_SinGrupoCorporativo__c)
					cuentaPersonalEncontreada.TAM_GrupoCorporativo__c = Sol.TAM_GrupoCorporativoRef__c != null ? Sol.TAM_GrupoCorporativoRef__c : null; //TAM_GrupoCorporativo__c;	

                //Ve si la solicitud ya tiene un grupo Corpo en Sol.TAM_GrupoCorporativoRef__c
                if (Sol.TAM_GrupoCorporativoRef__c != null)
                    cuentaPersonalEncontreada.TAM_GrupoCorporativo__c = Sol.TAM_GrupoCorporativoRef__c;
													
				cuentaPersonalEncontreada.BillingStreet = Sol.TAM_CalleRef__c != null ? Sol.TAM_CalleRef__c.toUpperCase() : null; //TAM_Calle__c
				cuentaPersonalEncontreada.BillingPostalCode = Sol.TAM_CodigoPostalRef__c != null ? Sol.TAM_CodigoPostalRef__c.toUpperCase() : null; //TAM_CodigoPostal__c
				cuentaPersonalEncontreada.Colonia__c = Sol.TAM_ColoniaRef__c != null ? Sol.TAM_ColoniaRef__c.toUpperCase() : null; //TAM_Colonia__c
				cuentaPersonalEncontreada.BillingCity = Sol.TAM_CiudadRef__c != null ? Sol.TAM_CiudadRef__c.toUpperCase() : null; //TAM_Ciudad__c
				cuentaPersonalEncontreada.BillingState = Sol.TAM_EstadoRef__c != null ? Sol.TAM_EstadoRef__c.toUpperCase() : null; //TAM_Estado__c
				cuentaPersonalEncontreada.BillingCountry = CandidatoPaso.TAM_Pais__c != null ? CandidatoPaso.TAM_Pais__c.toUpperCase() : null;				
				
				cuentaPersonalEncontreada.Correo_Electronico__c = Sol.TAM_CorreoCorporativoRef__c != null ? Sol.TAM_CorreoCorporativoRef__c : null; //TAM_CorreoElectronico__c
				cuentaPersonalEncontreada.Phone = Sol.TAM_TelefonoCorporativoRef__c != null ? Sol.TAM_TelefonoCorporativoRef__c.toUpperCase() : null; //TAM_TelefonoCuenta__c
				cuentaPersonalEncontreada.RFC__c = Sol.TAM_RFCRef__c != null ? Sol.TAM_RFCRef__c.toUpperCase() : null; //TAM_RFC__c
				
				//Aqui los datos del representante Legal
				cuentaPersonalEncontreada.TAM_NombreRL__c = Sol.TAM_NombreRefRL__c != null ? Sol.TAM_NombreRefRL__c.toUpperCase() : null; //TAM_NombreRL__c
				cuentaPersonalEncontreada.TAM_ApellidoPaternoRL__c = Sol.TAM_ApellidoPaternoRefRL__c != null ? Sol.TAM_ApellidoPaternoRefRL__c.toUpperCase() : null; //TAM_ApellidoPaternoRL__c
				cuentaPersonalEncontreada.TAM_ApellidoMaternoRL__c = Sol.TAM_ApellidoMaternoRefRL__c != null ? Sol.TAM_ApellidoMaternoRefRL__c.toUpperCase() : null; //TAM_ApellidoMaternoRL__c
				cuentaPersonalEncontreada.TAM_RFCRL__c = Sol.TAM_RFCRefRL__c != null ? Sol.TAM_RFCRefRL__c.toUpperCase() : null; //TAM_RFCRL__c
				cuentaPersonalEncontreada.TAM_CorreoElectronicoRL__c = Sol.TAM_CorreoElectronicoRefRL__c != null ? Sol.TAM_CorreoElectronicoRefRL__c.toUpperCase() : null; //TAM_CorreoElectronicoRL__c
				cuentaPersonalEncontreada.TAM_TelefonoRL__c = Sol.TAM_TelefonoRefRL__c != null ? Sol.TAM_TelefonoRefRL__c.toUpperCase() : null; //TAM_TelefonoRL__c
				cuentaPersonalEncontreada.TAM_DireccionRL__c = Sol.TAM_DireccionRL__c != null ? Sol.TAM_DireccionRL__c.toUpperCase() : null;

				cuentaPersonalEncontreada.TAM_ProgramaRango__c = Sol.TAM_ProgramaRandoRef__c;
				cuentaPersonalEncontreada.TAM_NombreComercial__c = Sol.TAM_NombreComercial__c != null ? Sol.TAM_NombreComercial__c.toUpperCase() : null;
				cuentaPersonalEncontreada.DenominacionSocial__c = Sol.TAM_RazonSocial__c != null ? Sol.TAM_RazonSocial__c.toUpperCase() : null;
				cuentaPersonalEncontreada.TAM_TipoPersonaProspecto__c = Sol.TAM_TipoPersona__c != null ? Sol.TAM_TipoPersona__c.toUpperCase() : null;		
                
                System.debug('EN creaClientePrograma NoConsecutivoFinal: ' + NoConsecutivoFinal);
                //Actualiza el campo de NoConsecutivoFinal
                if (!bTienNoConse)
                    cuentaPersonalEncontreada.TAM_NoConsecutivo__c = NoConsecutivoFinal;
                System.debug('EN creaClientePrograma cuentaPersonalEncontreada: ' + cuentaPersonalEncontreada);

				if (!Test.isRunningTest()){
					Database.UpsertResult dtSV = Database.upsert(cuentaPersonalEncontreada, Account.TAM_IdExternoNombre__c, false);
					if (!dtSV.success){
						bError = true;
						System.debug('EN creaClientePrograma ERROR A LA HORA DE CREAR EL REG DEL cuentaPersonalEncontreada: ' + dtSV.getErrors()[0].getMessage());
					}//Fin si !dtSV.success
       				if (dtSV.isSuccess())
       					setIdClte.add(dtSV.getId());					
				}//Fin si !Test.isRunningTest()
										
			}//Fin si cuentaPersonalEncontreada != null
				 		
        	//Toma los datos del prospecto asociado y actualizalos
        	LleadUpd.add(new Lead(
        			id = Sol.TAM_Candidato__c,
        			TAM_EstatusAutorizacion__c = 'Autorizado',
        			TAM_ComentariosAutorizacionCliente__c = Sol.TAM_Comentarios__c,
        			RecordTypeId = !bError ? VaRtLeadCteCreado : VaRtLeadEstAuto,
        			Status = !bError ? 'Cliente Creado' : 'Autorizado',
        			TAM_FechaVigenciaInicio__c = dFechaIni, //Sol.TAM_FechaVigenciaInicio__c,
        			TAM_FechaVigenciaFin__c = dFechaFin //Sol.TAM_FechaVigenciaFin__c
        			//,Rango__c = Sol.TAM_RangoFinall__c
        		)
        	);
        	System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma LleadUpd: ' + LleadUpd);

        	//Ve si tiene algo la lista de lLead
        	if(!LleadUpd.isEmpty()){
        		if (!Test.isRunningTest()){
        			List<Database.SaveResult> lSaveResultCand = Database.update(LleadUpd);
       			}//Fin si !Test.isRunningTest()
       		}//Fin del !LleadUpd.isEmpty()

       		String sIdFrupoCtesCorp = '';
       		//ahora pon la colaboración para el nuevo cliente con el grupo de Clientes Corporativos
       		for (Group grupoPublico : [Select g.Name, g.Id From Group g
					where Name = 'Clientes Corporativos']){
	    		sIdFrupoCtesCorp = grupoPublico.id;
	    	}
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma sIdFrupoCtesCorp: ' + sIdFrupoCtesCorp);
       		
       		List<AccountShare> lCtesCorp = new List<AccountShare>();
       		for (String setIdCltePaso : setIdClte){
	       		lCtesCorp.add(new AccountShare(
	    					UserOrGroupId = sIdFrupoCtesCorp,
	    					AccountId = setIdCltePaso,
	    					AccountAccessLevel = 'Edit',       				
	    					OpportunityAccessLevel = 'None'
	       			)
	       		);       			
       		}//Fin del for para setIdClte
       		System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma lCtesCorp: ' + lCtesCorp);
       		
	        //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
			List<Database.SaveResult> lDtbUpsRes = Database.insert(lCtesCorp, false);
			//Ve si hubo error
			for (Database.SaveResult objDtbUpsRes : lDtbUpsRes){
				if (!objDtbUpsRes.isSuccess())
		       		System.debug('Hubo un error a la hora de crear/Actualizar la colaboración con AccountShare ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
				if (objDtbUpsRes.isSuccess())
		       		System.debug('Los datos se Crearón/Actualizarón AccountShare CP con exito' + objDtbUpsRes.getId());
			}//Fin del for para lDtbUpsRes
			
		}catch(Exception ex){
			System.debug(LoggingLevel.INFO,'EN TAM_SolicitudesParaAprobarTriggerHandler creaClientePrograma ERROR: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
			//Alica el rollback
			Database.rollback(sp);
		}
    	
    	//Si es una prueba
    	//Database.rollback(sp);
    	
    }

    private static String getDistribuidor(String sOwnerId){
        System.debug('EN TAM_SolicitudesParaAprobarTriggerHandler.getDistribuidor sOwnerId '+ sOwnerId);

        String sDistId;
        String sCodigoDistribuidor;
        User usuarioActual = new User();
                
        //Los datos del distribuidor
        for (User usuario : [Select u.id, u.Name, u.CodigoDistribuidor__c, u.Email
                             From User u Where id = :sOwnerId and CodigoDistribuidor__c != null]){
                             usuarioActual = usuario;
        }//Fin del for para User
        sCodigoDistribuidor = usuarioActual.CodigoDistribuidor__c != null ? usuarioActual.CodigoDistribuidor__c : '57000'; 
        System.debug('EN TAM_SolicitudesParaAprobarTriggerHandler.getDistribuidor sCodigoDistribuidor '+ sCodigoDistribuidor);
        
        //Ya tienes el No de Dist entonces busca la cuenta asociada a ese Dist
        for (Account dist : [Select id, a.RecordType.Name, a.RecordTypeId, a.Codigo_Distribuidor__c 
            From Account a Where a.Codigo_Distribuidor__c =: sCodigoDistribuidor 
            and RecordTypeId =: VaRtAccRegDist]){
            sDistId = dist.id;
        }
        
        System.debug('EN TAM_SolicitudesParaAprobarTriggerHandler.getDistribuidor sDistId '+ sDistId);
        return sDistId;
    }

            
}